#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Uncommon operation with dataframes
# 
# Cheat sheet on uncommand operation with pandas such as reading a big file.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Pointer on notebooks
# 
# * [Rappel de ce que vous savez déjà mais avez peut-être oublié](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/notebooks/td2_eco_rappels_1a.html)
# * [Python pour un Data Scientist / Economiste](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/td_2a.html)
# * [Exercices Pratiques](http://www.xavierdupre.fr/app/actuariat_python/helpsphinx/i_seances_base.html)

# ## List of strings into binaries features

# In[2]:


import pandas
df = pandas.DataFrame([{"target":0, "features":["a", "b", "c"]},
                       {"target":1, "features":["a", "b"]},
                       {"target":2, "features":["c", "b"]}])
df


# In[3]:


df.features.str.join("*").str.get_dummies("*")


# ## Big files
# 
# Let's save some data first.

# In[4]:


from sklearn.datasets import load_breast_cancer
data = load_breast_cancer()
import pandas
df = pandas.DataFrame(data.data, columns=data.feature_names)
df.to_csv("cancer.txt", sep="\t", encoding="utf-8", index=False)


# ### first lines : nrows

# In[5]:


df = pandas.read_csv("cancer.txt", nrows=3)
df


# In[6]:


df = pandas.read_csv("cancer.txt", nrows=3, sep="\t")
df


# ### middle lines : nrows + skiprows

# In[7]:


df = pandas.read_csv("cancer.txt", nrows=3, skiprows=100, sep="\t", header=None)
df


# ### big files : iterator

# In[8]:


for piece, df in enumerate(pandas.read_csv("cancer.txt", iterator=True, sep="\t", chunksize=3)):
    print(piece, df.shape)
    if piece > 2:
        break


# ### sample on big files : iterator + concat

# In[9]:


samples = []
for df in pandas.read_csv("cancer.txt", iterator=True, sep="\t", chunksize=30):
    sample = df.sample(3)
    samples.append(sample)
dfsample = pandas.concat(samples)
dfsample.shape


# In[10]: